/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <compiz.h>

#define _GOTOVP_OPTIONS_INTERNAL
#include "gotovp_options.h"

static int displayPrivateIndex;

static CompMetadata gotovpOptionsMetadata;

static CompPluginVTable *gotovpPluginVTable = NULL;
CompPluginVTable gotovpOptionsVTable;

#define GET_GOTOVP_OPTIONS_DISPLAY(d) \
        ((GotovpOptionsDisplay *) (d)->privates[displayPrivateIndex].ptr)

#define GOTOVP_OPTIONS_DISPLAY(d) \
        GotovpOptionsDisplay *od = GET_GOTOVP_OPTIONS_DISPLAY (d)

#define GET_GOTOVP_OPTIONS_SCREEN(s, od) \
        ((GotovpOptionsScreen *) (s)->privates[(od)->screenPrivateIndex].ptr)

#define GOTOVP_OPTIONS_SCREEN(s) \
        GotovpOptionsScreen *os = GET_GOTOVP_OPTIONS_SCREEN (s, GET_GOTOVP_OPTIONS_DISPLAY (s->display))

typedef struct _GotovpOptionsDisplay
{
    int screenPrivateIndex;

    CompOption opt[GotovpDisplayOptionNum];
    gotovpDisplayOptionChangeNotifyProc notify[GotovpDisplayOptionNum];
} GotovpOptionsDisplay;

typedef struct _GotovpOptionsScreen
{
} GotovpOptionsScreen;

CompAction * gotovpGetBegin (CompDisplay *d)
{
    GOTOVP_OPTIONS_DISPLAY(d);
    return &od->opt[GotovpDisplayOptionBegin].value.action;
}

void gotovpSetBeginInitiate (CompDisplay *d, CompActionCallBackProc init)
{
    GOTOVP_OPTIONS_DISPLAY(d);
    od->opt[GotovpDisplayOptionBegin].value.action.initiate = init;
}

void gotovpSetBeginTerminate (CompDisplay *d, CompActionCallBackProc term)
{
    GOTOVP_OPTIONS_DISPLAY(d);
    od->opt[GotovpDisplayOptionBegin].value.action.terminate = term;
}

CompOption * gotovpGetBeginOption (CompDisplay *d)
{
    GOTOVP_OPTIONS_DISPLAY(d);
    return &od->opt[GotovpDisplayOptionBegin];
}

void gotovpSetBeginNotify (CompDisplay *d, gotovpDisplayOptionChangeNotifyProc notify)
{
    GOTOVP_OPTIONS_DISPLAY(d);
    od->notify[GotovpDisplayOptionBegin] = notify;
}

CompOption * gotovpGetDisplayOption (CompDisplay *d, GotovpDisplayOptions num)
{
    GOTOVP_OPTIONS_DISPLAY(d);
    return &od->opt[num];
}

static const CompMetadataOptionInfo gotovpOptionsDisplayOptionInfo[] = {
    { "begin", "action", 0, 0, 0 },
};

static Bool gotovpOptionsSetDisplayOption (CompPlugin *plugin, CompDisplay *d, char *name, CompOptionValue *value)
{
    GOTOVP_OPTIONS_DISPLAY(d);
    CompOption *o;
    int        index;

    o = compFindOption (od->opt, GotovpDisplayOptionNum, name, &index);

    if (!o)
        return FALSE;

    switch (index)
    {
     case GotovpDisplayOptionBegin:
        if (compSetDisplayOption (d, o, value))
        {
            if (od->notify[GotovpDisplayOptionBegin])
                (*od->notify[GotovpDisplayOptionBegin]) (d, o, GotovpDisplayOptionBegin);
            return TRUE;
        }
        break;
    default:
        break;
    }
    return FALSE;
}

static CompOption * gotovpOptionsGetDisplayOptions (CompPlugin *plugin, CompDisplay *d, int *count)
{
    GOTOVP_OPTIONS_DISPLAY(d);
    *count = GotovpDisplayOptionNum;
    return od->opt;
}

static Bool gotovpOptionsInitScreen (CompPlugin *p, CompScreen *s)
{
    GotovpOptionsScreen *os;
    
    GOTOVP_OPTIONS_DISPLAY (s->display);

    os = calloc (1, sizeof(GotovpOptionsScreen));
    if (!os)
        return FALSE;

    s->privates[od->screenPrivateIndex].ptr = os;

        if (gotovpPluginVTable && gotovpPluginVTable->initScreen)
        return gotovpPluginVTable->initScreen (p, s);
    return TRUE;
}

static void gotovpOptionsFiniScreen (CompPlugin *p, CompScreen *s)
{
    if (gotovpPluginVTable && gotovpPluginVTable->finiScreen)
        return gotovpPluginVTable->finiScreen (p, s);

    GOTOVP_OPTIONS_SCREEN (s);

    free (os);
}

static Bool gotovpOptionsInitDisplay (CompPlugin *p, CompDisplay *d)
{
    GotovpOptionsDisplay *od;
   
    
    od = calloc (1, sizeof(GotovpOptionsDisplay));
    if (!od)
        return FALSE;

    od->screenPrivateIndex = allocateScreenPrivateIndex(d);
    if (od->screenPrivateIndex < 0)
    {
        free(od);
        return FALSE;
    }

    d->privates[displayPrivateIndex].ptr = od;

    if (!compInitDisplayOptionsFromMetadata (d, &gotovpOptionsMetadata, gotovpOptionsDisplayOptionInfo, od->opt, GotovpDisplayOptionNum))
    {
        free (od);
        return FALSE;
    }
    if (gotovpPluginVTable && gotovpPluginVTable->initDisplay)
        return gotovpPluginVTable->initDisplay (p, d);
    return TRUE;
}

static void gotovpOptionsFiniDisplay (CompPlugin *p, CompDisplay *d)
{
    if (gotovpPluginVTable && gotovpPluginVTable->finiDisplay)
        return gotovpPluginVTable->finiDisplay (p, d);

    GOTOVP_OPTIONS_DISPLAY (d);

    freeScreenPrivateIndex(d, od->screenPrivateIndex);

    compFiniDisplayOptions (d, od->opt, GotovpDisplayOptionNum);

    free (od);
}

static Bool gotovpOptionsInit (CompPlugin *p)
{
    displayPrivateIndex = allocateDisplayPrivateIndex();
    if (displayPrivateIndex < 0)
        return FALSE;

    if (!compInitPluginMetadataFromInfo (&gotovpOptionsMetadata, "gotovp",gotovpOptionsDisplayOptionInfo, GotovpDisplayOptionNum, 0, 0))
        return FALSE;

    compAddMetadataFromFile (&gotovpOptionsMetadata, "gotovp");
    if (gotovpPluginVTable && gotovpPluginVTable->init)
        return gotovpPluginVTable->init (p);
    return TRUE;
}

static void gotovpOptionsFini (CompPlugin *p)
{
    if (gotovpPluginVTable && gotovpPluginVTable->fini)
        return gotovpPluginVTable->fini (p);

    if (displayPrivateIndex >= 0)
        freeDisplayPrivateIndex(displayPrivateIndex);

    compFiniMetadata (&gotovpOptionsMetadata);
}

static CompMetadata *
gotovpOptionsGetMetadata (CompPlugin *plugin)
{
    return &gotovpOptionsMetadata;
}

CompPluginVTable *getCompPluginInfo (void)
{
    if (!gotovpPluginVTable)
    {
        gotovpPluginVTable = gotovpOptionsGetCompPluginInfo ();
        memcpy(&gotovpOptionsVTable, gotovpPluginVTable, sizeof(CompPluginVTable));
        gotovpOptionsVTable.getMetadata = gotovpOptionsGetMetadata;
        gotovpOptionsVTable.init = gotovpOptionsInit;
        gotovpOptionsVTable.fini = gotovpOptionsFini;
        gotovpOptionsVTable.initDisplay = gotovpOptionsInitDisplay;
        gotovpOptionsVTable.finiDisplay = gotovpOptionsFiniDisplay;
        gotovpOptionsVTable.initScreen = gotovpOptionsInitScreen;
        gotovpOptionsVTable.finiScreen = gotovpOptionsFiniScreen;
        gotovpOptionsVTable.getDisplayOptions = gotovpOptionsGetDisplayOptions;
	gotovpOptionsVTable.setDisplayOption = gotovpOptionsSetDisplayOption;
	
    }
    return &gotovpOptionsVTable;
}

